interface IntOp{
  public int transform(int i);  // Transform arg
  public int opsPerformed();    // Track # calls to transform(..)
  public String toString();     // Show string repr
}

class DoubleIt implements IntOp{
  private int opsPerformed;
  public int transform(int i){
    this.opsPerformed++;
    return 2*i;
  }
  public int opsPerformed(){
    return this.opsPerformed;
  }
  public String toString(){
    return "DoubleIt";
  }
}

class IncrIt implements IntOp{
  private int opsPerformed;
  public int transform(int i){
    this.opsPerformed++;
    return i+1;
  }
  public int opsPerformed(){
    return this.opsPerformed;
  }
  public String toString(){
    return "IncrIt";
  }
}

class TwoPowIt implements IntOp{
  private int opsPerformed;
  public int transform(int i){
    this.opsPerformed++;
    int pow = 1;
    for(int p=0; p<i; p++){
      pow *= 2;
    }
    return pow;
  }
  public int opsPerformed(){
    return this.opsPerformed;
  }
  public String toString(){
    return "TwoPowIt";
  }
}


public class OpDemo{
  public static void main(String args[]){
    IntOp [] ops = {
      new DoubleIt(),
      new IncrIt(),
      new TwoPowIt(),
    };

    int arg = 10;
    System.out.printf("Transforms of %d\n",arg);
    for(IntOp op : ops){
      int ans = op.transform(arg);
      System.out.printf("%s (%d) : %d\n",op,arg,ans);
    }
    // One more transform for 0th op
    ops[0].transform(5);

    System.out.println();
    System.out.printf("Number of transforms for each op\n");
    for(IntOp op : ops){
      int opsPerformed = op.opsPerformed();
      System.out.printf("%s : %d\n",op,opsPerformed);
    }
  }
}
