// Total of a set of numbers
public class Total extends Statistic {
  protected double sum;
  public Total(){
    this.sum=0.0;
  }
  public void update(String s, double d){
    this.sum += d;
  }
  public double value(){ return sum; }
  public String toString(){
    return
      String.format("total %5.2f", this.sum);
  }
}

class Mean extends Statistic{
  // Fields?
  private double count;
  private double sum;

  // Constructor?
  public Mean(){
    this.count = 0;
    this.sum = 0;
  }

  public void update(String s, double d){
    this.sum += d;
    this.count++;
  }
  public double value(){
    return this.sum / this.count;
  }
  public String toString(){
    return
      String.format("mean %5.2f", this.value());
  }

}

class Max extends Statistic {
  double max;
  String maxName;

  public Max(){
    this.max = 0.0;
    this.maxName = "";
  }
  public void update(String s, double d){
    if(d > this.max){
      this.max = d;
      this.maxName = s;
    }
  }
  public double value(){
    return this.max;
  }
  public String toString(){
    return
      String.format("max %5.2f by %s",
                    this.value(), this.maxName);
  }


}
