// Calculates the running maximum of a series of numbers. Properly
// handles multiple max holders
public class Max implements Statistic {
  private double max;
  private String name;

  public Max(){
    this.max= Double.NEGATIVE_INFINITY;
    this.name = "Nobody";
  }

  public void update(String s, double d){
    if(d > this.max){
      this.max = d;
      this.name = s;
    }
    else if(d == this.max){
      this.name += " and " + s;
    }
  }
  public double value() { return this.max; }

  public String toString(){
    return
      String.format("max %5.2f by %s", this.max, this.name);
  }
}
